'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactPrimitives = require('react-primitives');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LinearGradient = function (_PureComponent) {
  _inherits(LinearGradient, _PureComponent);

  function LinearGradient(props) {
    _classCallCheck(this, LinearGradient);

    var _this = _possibleConstructorReturn(this, (LinearGradient.__proto__ || Object.getPrototypeOf(LinearGradient)).call(this, props));

    _this.state = {
      width: 1,
      height: 1
    };
    return _this;
  }

  _createClass(LinearGradient, [{
    key: 'measure',
    value: function measure(_ref) {
      var nativeEvent = _ref.nativeEvent;

      this.setState({
        width: nativeEvent.layout.width,
        height: nativeEvent.layout.height
      });
    }
  }, {
    key: 'getAngle',
    value: function getAngle() {
      // Math.atan2 handles Infinity
      var angle = Math.atan2(this.state.width * (this.props.end.y - this.props.start.y), this.state.height * (this.props.end.x - this.props.start.x)) + Math.PI / 2;
      return angle + 'rad';
    }
  }, {
    key: 'getColors',
    value: function getColors() {
      var _this2 = this;

      this.props.colors.map(function (color, index) {
        var location = _this2.props.locations[index];
        var locationStyle = '';
        if (location) {
          locationStyle = ' ' + location * 100 + '%';
        }
        return color + locationStyle;
      }).join(',');
    }
  }, {
    key: 'render',
    value: function render() {
      return _jsx(_reactPrimitives.View, {
        style: [this.props.style, { backgroundImage: 'linear-gradient(' + this.getAngle() + ',' + this.getColors() + ')' }],
        onLayout: this.measure
      }, void 0, this.props.children);
    }
  }]);

  return LinearGradient;
}(_react.PureComponent);

LinearGradient.defaultProps = {
  start: {
    x: 0.5,
    y: 0
  },
  end: {
    x: 0.5,
    y: 1
  },
  locations: [],
  colors: []
};
LinearGradient.propTypes = {
  start: _propTypes2.default.object,
  end: _propTypes2.default.object,
  locations: _propTypes2.default.array,
  colors: _propTypes2.default.array
};

exports.default = LinearGradient;